%global vertag M4

Name:           sisu
Epoch:          1
Version:        0.0.0
Release:        %mkrel 0.4.%{vertag}.5
Summary:        Eclipse dependency injection framework
Group:          Development/Java
# bundled asm is under BSD
License:        EPL and BSD
URL:            http://eclipse.org/sisu

# TODO: unbundle asm
# TODO: install EPL license file
# TODO: inject pom.properties
# TODO: regenerate build-requires
# TODO: generate proper requires
# convert lazy sed patches to real patches and upstream

Source0:        http://git.eclipse.org/c/%{name}/org.eclipse.%{name}.inject.git/snapshot/milestones/%{version}.%{vertag}.tar.bz2#/org.eclipse.%{name}.inject-%{version}.%{vertag}.tar.bz2
Source1:        http://git.eclipse.org/c/%{name}/org.eclipse.%{name}.plexus.git/snapshot/milestones/%{version}.%{vertag}.tar.bz2#/org.eclipse.%{name}.plexus-%{version}.%{vertag}.tar.bz2

BuildArch:      noarch

BuildRequires:  maven-local
BuildRequires:  mvn(ch.qos.logback:logback-classic)
BuildRequires:  mvn(com.google.inject.extensions:guice-assistedinject)
BuildRequires:  mvn(com.google.inject:guice)
BuildRequires:  mvn(javax.enterprise:cdi-api)
BuildRequires:  mvn(junit:junit)
BuildRequires:  mvn(org.apache.felix:org.apache.felix.framework)
BuildRequires:  mvn(org.eclipse.tycho:tycho-maven-plugin)
BuildRequires:  mvn(org.osgi:org.osgi.core)
BuildRequires:  mvn(org.sonatype.oss:oss-parent)
BuildRequires:  mvn(org.codehaus.mojo:build-helper-maven-plugin)
BuildRequires:  mvn(org.jacoco:jacoco-maven-plugin)

BuildRequires:  osgi(aopalliance)
BuildRequires:  osgi(com.google.guava)
BuildRequires:  osgi(javax.el)
BuildRequires:  osgi(javax.enterprise.cdi-api)
BuildRequires:  osgi(javax.inject)
BuildRequires:  osgi(javax.servlet)
BuildRequires:  osgi(javax.xml.rpc)
BuildRequires:  osgi(org.apache.geronimo.specs.geronimo-annotation_1.1_spec)
BuildRequires:  osgi(org.apache.geronimo.specs.geronimo-ejb_3.1_spec)
BuildRequires:  osgi(org.codehaus.plexus.classworlds)
BuildRequires:  osgi(org.codehaus.plexus.component-annotations)
BuildRequires:  osgi(org.codehaus.plexus.utils)
BuildRequires:  osgi(org.eclipse.jdt.apt.core)
BuildRequires:  osgi(org.eclipse.osgi)
BuildRequires:  osgi(org.hamcrest.core)
BuildRequires:  osgi(org.junit)
BuildRequires:  osgi(org.sonatype.sisu.guice)
BuildRequires:  osgi(org.testng)
BuildRequires:  osgi(slf4j.api)

#FIXME: Remove when fixed in xmvn
BuildRequires: sisu-inject

%description
Java dependency injection framework with backward support for plexus and bean
style dependency injection.

%package        inject
Summary:        Sisu inject POM

Obsoletes:      %{name}                   < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-bean              < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-bean-binders      < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-bean-containers   < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-bean-converters   < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-bean-inject       < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-bean-locators     < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-bean-reflect      < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-bean-scanners     < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-containers        < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-inject-bean       < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-inject-plexus     < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-osgi-registry     < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-parent            < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-plexus-binders    < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-plexus-converters < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-plexus-lifecycles < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-plexus-locators   < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-plexus-metadata   < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-plexus-scanners   < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-plexus-shim       < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-registries        < %{epoch}:%{version}-%{release}
Obsoletes:      %{name}-spi-registry      < %{epoch}:%{version}-%{release}

%description    inject
This package contains %{summary}.

%package        plexus
Summary:        Sisu Plexus POM

# XXX: temporary hack
Provides:       mvn(org.sonatype.sisu:sisu-inject-plexus)

%description    plexus
This package contains %{summary}.

%package        javadoc
Summary:        API documentation for Sisu
Group:          Documentation

%description    javadoc
This package contains %{summary}.

%prep
%setup -q -c -T
tar xf %{SOURCE0} && mv milestones/* sisu-inject && rmdir milestones
tar xf %{SOURCE1} && mv milestones/* sisu-plexus && rmdir milestones

%mvn_file ":{*}" @1
%mvn_package ":*{inject,plexus}" @1
%mvn_package : __noinstall

%pom_disable_module org.eclipse.sisu.inject.tests sisu-inject
%pom_disable_module org.eclipse.sisu.plexus.tests sisu-plexus

for target in \
    sisu-inject/org.eclipse.sisu.inject/build.target \
    sisu-plexus/org.eclipse.sisu.plexus/build.target
do
    sed -i '/<unit/s|version="[^"]*"||' $target
    sed -i '/<repository/s|location="[^"]*"|location="file:'"$PWD"'/.m2/p2/repo"|' $target
    sed -i '/<unit id="plexus-deps"/s|.*|<unit id="org.codehaus.plexus.classworlds"/><unit id="org.codehaus.plexus.component-annotations"/><unit id="org.codehaus.plexus.utils"/>|' $target
    sed -i '/<unit id="org.aopalliance"/s|.*|<unit id="aopalliance"/>|' $target
    sed -i '/<unit id="cdi.api"/s|.*|<unit id="javax.enterprise.cdi-api"/>|' $target
    sed -i '/<unit id="javax.annotation"/s|.*|<unit id="org.apache.geronimo.specs.geronimo-annotation_1.1_spec"/>|' $target
    sed -i '/<unit id="javax.ejb"/s|.*|<unit id="org.apache.geronimo.specs.geronimo-ejb_3.1_spec"/>|' $target
    sed -i '/<unit id="com.google.inject"/s|.*|<unit id="org.sonatype.sisu.guice"/>|' $target
    sed -i '/<unit id="org.slf4j.api"/s|.*|<unit id="slf4j.api"/>|' $target
done

for pom in \
    sisu-inject/org.eclipse.sisu.inject \
    sisu-inject/org.eclipse.sisu.inject.extender \
    sisu-plexus/org.eclipse.sisu.plexus
do
    %pom_remove_plugin :animal-sniffer-maven-plugin $pom
done

sed -i '260s/<Object/<String/g' `find sisu-inject -name SisuActivator.java`
# Incompatible version of Plexus Classworlds (upstreamable)
sed -i '198s/return/&(Class)/' `find -name ComponentDescriptor.java`

cat <<EOF >pom.xml
<project>
  <modelVersion>4.0.0</modelVersion>
  <groupId>org.fedoraproject.maven</groupId>
  <artifactId>aggregator-project</artifactId>
  <version>dummy</version>
  <packaging>pom</packaging>
  <modules>
    <module>sisu-inject</module>
    <module>sisu-plexus</module>
  </modules>
</project>
EOF

%build
# Tycho inject dependencies with system scope.  Disable installation
# of effective POMs until Mvn can handle system-scoped deps.
%mvn_build -f -i
for mod in inject plexus; do
    %mvn_artifact sisu-${mod}/pom.xml
    %mvn_artifact sisu-${mod}/org.eclipse.sisu.${mod}/pom.xml sisu-${mod}/org.eclipse.sisu.${mod}/target/org.eclipse.sisu.${mod}-%{version}.%{vertag}.jar
done

%install
%mvn_install

# XXX: temporary hack
install -d -m 755 %{buildroot}%{_javadir}/%{name}
ln -sf %{_javadir}/org.eclipse.%{name}.inject.jar \
   %{buildroot}%{_javadir}/%{name}/sisu-inject-bean.jar
ln -sf %{_javadir}/org.eclipse.%{name}.plexus.jar \
   %{buildroot}%{_javadir}/%{name}/sisu-inject-plexus.jar

%clean
find . -type d -exec chmod u+rx {} +

%files inject -f .mfiles-inject

%files plexus -f .mfiles-plexus
%_datadir/java/sisu/sisu-inject-bean.jar
%_datadir/java/sisu/sisu-inject-plexus.jar

%files javadoc -f .mfiles-javadoc



%changelog
* Sun Dec 29 2013 dmorgan <dmorgan> 1:0.0.0-0.4.M4.5.mga4
+ Revision: 563138
- Fix %%clean issue

* Sat Oct 19 2013 umeabot <umeabot> 1:0.0.0-0.4.M4.4.mga4
+ Revision: 535858
- Mageia 4 Mass Rebuild

* Fri Sep 20 2013 dmorgan <dmorgan> 1:0.0.0-0.4.M4.3.mga4
+ Revision: 482594
- Rebuild against new javapackages
- Fix build
- Update to upstream version 0.0.0.M4

* Wed Sep 18 2013 dmorgan <dmorgan> 2.3.0-3.mga4
+ Revision: 481234
- Fix dependencies on javax.inject and javax.enterprise.inject
  Remove unneeded animal-sniffer buildrequires
- Try to fix require exclude

* Fri Jul 12 2013 dmorgan <dmorgan> 2.3.0-1.mga4
+ Revision: 453340
- New version

* Mon Jan 14 2013 umeabot <umeabot> 2.2.3-2.mga3
+ Revision: 382093
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Jul 09 2012 dmorgan <dmorgan> 2.2.3-1.mga3
+ Revision: 268977
- New version 2.2.3

* Thu Apr 28 2011 dmorgan <dmorgan> 2.1.1-4.mga1
+ Revision: 93141
- Rebuild after bootstrapping

* Wed Apr 27 2011 dmorgan <dmorgan> 2.1.1-3.mga1
+ Revision: 92106
- Rebuild after bootstrapping
- imported package sisu


* Tue Mar  1 2011 Stanislav Ochotnicky <sochotnicky@redhat.com> - 2.1.1-2
- Add atinject into poms as dependency

* Mon Feb 28 2011 Stanislav Ochotnicky <sochotnicky@redhat.com> - 2.1.1-1
- Update to 2.1.1
- Update patch
- Disable guice-eclipse for now

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.3.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Feb  2 2011 Stanislav Ochotnicky <sochotnicky@redhat.com> - 1.4.3.2-1
- Update to latest upstream version
- Versionless jars & javadocs

* Mon Oct 18 2010 Stanislav Ochotnicky <sochotnicky@redhat.com> - 1.4.2-2
- Add felix-framework BR

* Thu Oct 14 2010 Stanislav Ochotnicky <sochotnicky@redhat.com> - 1.4.2-1
- Initial version of the package


